/******************************************************************
Version identification:
@(#)Sim96Target.h	1.8	11/25/92

Copyright (c) 1990, 1991, 1992 The Regents of the University of California.
All rights reserved.

Permission is hereby granted, without written agreement and without
license or royalty fees, to use, copy, modify, and distribute this
software and its documentation for any purpose, provided that the above
copyright notice and the following two paragraphs appear in all copies
of this software.

IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY 
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES 
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF 
THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF 
SUCH DAMAGE.

THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.
							COPYRIGHTENDKEY

 Programmer: J. Buck, J. Pino

 Target for Motorola 96000 assembly code generation that runs its
 output on the simulator.

*******************************************************************/
#ifndef _Sim96Target_h
#define _Sim96Target_h 1

#ifdef __GNUG__
#pragma interface
#endif

#include "CG96Target.h"
#include "MotorolaSimTarget.h"

class Sim96Target : public CG96Target, public MotorolaSimTarget {
private:
	void initStates();
protected:
        void headerCode();
        void trailerCode();
public:
	Sim96Target(const char*,const char*);
	Sim96Target(const Sim96Target&);
	int compileCode();
	int loadCode();
	int runCode();
	Block* makeNew() const;
	int isA(const char*) const;
};

#endif
