static const char file_id[] = "../../../../src/domains/thor/stars/ThorINV.chdl";

////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 1990, 1991, 1992 The Regents of the University of California.
// All rights reserved.
// See the file ~ptolemy/copyright for copyright notice, 
// limitation of liability, and disclaimer of warranty provisions. 
//
////////////////////////////////////////////////////////////////////////

////

//  Conversion done 1992/11/26, 12:42:14 by pepp version 2.6.
//  Input is coming from file "../../../../src/domains/thor/stars/ThorINV.chdl".

#include "ThorStar.h"
#include "ThorState.h"
#include "libarp.h"
#include "KnownBlock.h"
#include "ThorPrintOverl.h"
#include "ThorErrHandler.h"

static ThorErrHandler* StatErrHandler = 0;

#ifdef EXITMOD
#undef EXITMOD
#endif
#define EXITMOD(x) StatErrHandler->status = x; return;
#define exit(x) StatErrHandler->status = x; StatErrHandler->flush(); return;

/*	INV()
 *		Inverter gate.
 */

const char *star_nm_ThorINV = "ThorINV";

class ThorINV : public ThorStar
{
private:

//	    Inport list: (between lines 9 and 11)
    InThorPort		indat;

//	    Outport list: (between lines 13 and 15)
    OutThorPort		outdat;

public:
    int			isItModel() { return TRUE; }
    ThorINV();		// Constructor
    void		go();
    void		setup();
    Block*		makeNew() const { LOG_NEW; return new ThorINV; }

};

ThorINV :: ThorINV ()	// Constructor
{
    setDescriptor("\n"
"** This star's code is generated by pepp, version 2.6, from a chdl model. **\n""\n"

"/*	INV()\n"
" *		Inverter gate.\n"
" */\n");

//	Ports:

    addPort(indat.setPort("indat",this));

    addPort(outdat.setPort("outdat",this));
}

void ThorINV :: setup()
{
}

static ThorINV proto;
static KnownBlock entry(proto,"INV");

void ThorINV :: go()
{
#define index  strchr
#define new   _new_

    ThorErrHandler errHandler(this,ThorPrint::getErrMsgBuf(),&StatErrHandler);
    StatErrHandler = &errHandler;

// line 6 "../../../../src/domains/thor/stars/ThorINV.chdl"

#define	RCSID "$Header: INV.c,v 1.2 86/12/30 23:49:20 div Exp $"

// line 12 "../../../../src/domains/thor/stars/ThorINV.chdl"

// line 16 "../../../../src/domains/thor/stars/ThorINV.chdl"

/*	IOStest(1,1,0,INV);	*/	/* check # of I,O,& S	*/
					/* form complement	*/
	if (indat > 3)
		outdat = UNDEF;
	else
		outdat = vinv[indat];

	EXITMOD(0);
}

