static const char file_id[] = "../../../../src/domains/thor/stars/ThorNO_CONN.chdl";

////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 1990, 1991, 1992 The Regents of the University of California.
// All rights reserved.
// See the file ~ptolemy/copyright for copyright notice, 
// limitation of liability, and disclaimer of warranty provisions. 
//
////////////////////////////////////////////////////////////////////////

////

//  Conversion done 1992/11/26, 12:42:08 by pepp version 2.6.
//  Input is coming from file "../../../../src/domains/thor/stars/ThorNO_CONN.chdl".

#include "ThorStar.h"
#include "ThorState.h"
#include "libarp.h"
#include "KnownBlock.h"
#include "ThorPrintOverl.h"
#include "ThorErrHandler.h"

static ThorErrHandler* StatErrHandler = 0;

#ifdef EXITMOD
#undef EXITMOD
#endif
#define EXITMOD(x) StatErrHandler->status = x; return;
#define exit(x) StatErrHandler->status = x; StatErrHandler->flush(); return;

/*	NO_CONN()
 *	Floating output gate 	(i.e. un-connected output lead)
 */

const char *star_nm_ThorNO_CONN = "ThorNO_CONN";

class ThorNO_CONN : public ThorStar
{
private:

//	    Inport list: (between lines 9 and 11)
    MultiInThorPort	indat;

public:
    int			isItMonitor() { return TRUE; }
    ThorNO_CONN();		// Constructor
    void		go();
    void		setup();
    Block*		makeNew() const { LOG_NEW; return new ThorNO_CONN; }

};

ThorNO_CONN :: ThorNO_CONN ()	// Constructor
{
    setDescriptor("\n"
"** This star's code is generated by pepp, version 2.6, from a chdl model. **\n""\n"

"/*	NO_CONN()\n"
" *	Floating output gate 	(i.e. un-connected output lead)\n"
" */\n");

//	Ports:

    addPort(indat.setPort("indat",this));
}

void ThorNO_CONN :: setup()
{
}

static ThorNO_CONN proto;
static KnownBlock entry(proto,"NO_CONN");

void ThorNO_CONN :: go()
{
#define index  strchr
#define new   _new_

    ThorErrHandler errHandler(this,ThorPrint::getErrMsgBuf(),&StatErrHandler);
    StatErrHandler = &errHandler;

// line 7 "../../../../src/domains/thor/stars/ThorNO_CONN.chdl"

#define RCSID "$Header: NO_CONN.c,v 1.2 87/03/08 15:13:05 rla Exp $"

// line 12 "../../../../src/domains/thor/stars/ThorNO_CONN.chdl"

	EXITMOD(0);
}

